
/*

  Przyklad wykorzystania bliblioteki procedur dla operacji input/output:

  OPEN		(BYTE,BYTE,WORD)
  READ		(BYTE,BYTE,WORD,WORD)
  CLOSE		(BYTE)
  PCIOV

  PUTLINE	(WORD)		- procedura PUTLINE z biblioteki STDIO

  Przykladowy program otwiera do odczytu plik 'IO.OBX' i odczytuje z niego 80 bajtow ktore
  umieszcza w pamieci od adresu $BC40 (pamiec obrazu), w przypadku bledow transmisji
  wyswietla komunikat z numerem bledu 'I/O ERROR $??'

*/

	org $2000

main
	open	#$10 , #4 , #name
	tya
	bmi	stop

	read	#$10 , #7 , #$bc40 , #80

stop
	close	#$10

	jmp	*			; THE END


name	.by	'D:IO.OBX' $9b

; PROCEDURES

	.link	'lib\io_lib.obx'
	.link	'..\stdio\lib\putline.obx'

*---
	run main
