;-----------
; CONSTANTS
;-----------

size_frame8_opponent  = $0180 ; po 8 znakw na wiersz
size_frame9_opponent  = $01B0 ; po przerobieniu na 9 znakw w wierszu
size_frame_player     = $00F0

; kolory gracza (trzeci kolor powstaje przez ORA)
color_player1        = $30
color_player2        = $08

; numery FX-w generujcych rzne dwiki w grze
throw_chain_FX       = $00  ; rzucanenie cuchem - CHAIN
hit_player_FX        = $01  ; trafiony gracz
fly_player_FX        = $02  ; latajcy gracz
turn_nuncha_FX       = $05  ; krcenie nunchako - NUNCHA  (uwaga modyfikowany instrument na przerw. VBL!)
turn_pole_FX         = $05  ; krcenie kijem - POLE       (uwaga modyfikowany instrument na przerw. VBL!)
throw_star_FX        = $06  ; rzucanie gwiazdk - STAR
new_life_FX          = $07  ; dwik generowany gdy gracz dostaje nowe ycie
blow_player_FX       = $08  ; wykonaie dowolnego ciosu przez gracza

; YieMusicFX3
TitleMusic           = $00  ; muzyka tytuowa

; YieMusicFX2
CountScoreMusic1     = $00  ; zliczanie punktw gracza - po wygranej walce (wstp)
CountScoreMusic2     = $01  ; zliczanie punktw gracza - po wygranej walce (koniec)

; YieMusicFX
IntroMusic           = $2a
FirstMusic           = $00
SecondMusic          = $03
DoorMusic            = $0e
DeathIsCommingMusic  = $06
DeadOpponentMusic    = $0b
DeadPlayerMusic      = $08
EndMusic             = $13
GetNameMusic         = $11
WinnerMusic          = $23

JVB                  = 65   ; stae do tworzenia Display Listy
Mode4                = 4
Mode2                = 2
ModeE                = 14
ModeF                = 15
DLI                  = 128
LMS                  = 64
Blank8               = $70
Blank6               = $50
Blank4               = $30
Blank2               = $10

Buchu                = 0    ; Ponumerowani kolejni przeciwnicy UWAGA! bit7 musi by 0
Star                 = 2
Nuncha               = 4
Pole                 = 6
Chain                = 8
Club                 = 10
Fan                  = 12
Sword                = 14
Tonfun               = 16
Blue                 = 18  ; UWAGA! bit7 musi by 0

Escape               = 20   ; kod ucieczki, jego wygenerowanie oznacza, e przeciwnik musi oddali si od gracza
Escape2              = 22

Screen160x200Buffor1 = $8000 ; pocztek 1-szego ekranu
Screen160x200Buffor2 = $A400 ; pocztek 2-giego ekranu
PMG1                 = $D800 ; 2KB obszar PMG nr1
PMG2                 = $E000 ; 2KB obszar PMG nr2
Screen48x25          = $E800 ; ekran tekstowy  - 48x25
Screen40x25          = $E800 ; ekran tekstowy  - 40x25
Screen48x1           = $F400 ; ekran ze strzak (t na dole)

FIRE    = 0
NOFIRE  = 16
Freq100 = 255            ; prawdopodobiestwo trafienia danym ciosem
Freq90  = Freq75+Freq15
Freq75  = Freq50+Freq25
Freq50  = Freq25+Freq25
Freq35  = Freq25+Freq10
Freq25  = Freq20+Freq05
Freq20  = Freq10+Freq10
Freq15  = Freq10+Freq05
Freq10  = Freq05+Freq05
Freq05  = 255/20

;------------------------------------------------------------------------------------------------------------------------
;                                                       PAGE 0
;------------------------------------------------------------------------------------------------------------------------

    org $0000
@proc_vars_adr         .ds 16 ;16 bajtw na zmienne
COUNTER1               .ds 1  ; licznik oglnego wykorzystania
COUNTER2               .ds 1
COUNTER3               .ds 1
COUNTER4               .ds 1
address1               .ds 2 ; adres oglnego wykorzystania
adr_scr                .ds 2 ; adres ekranu (txt)
XCoordinatePlayer      .ds 1
YCoordinatePlayer      .ds 1
XCoordinateOpponent    .ds 1
YCoordinateOpponent    .ds 1
   .if [*-$0000]>$1c                                 ; $1C-$1F wykorzystywane przez player MPT
      .print
      .print 'konflikt z danymi MPT na stronie zerowej!'
   .endif

   org $0020
AddrArrow              .ds 2
StoreAddrArrow         .ds 2
AddrArrowOnScreen      .ds 2
StoreAddrArrowOnScreen .ds 2
AddrXYOffset           .ds 2
AddrOpponent           .ds 2
AddrWeapon             .ds 2
ActualCharsetDLI       .ds 1
address4Opponent       .ds 2
save_PORTB             .ds 1
IsClearLeftOutline     .ds 1
IsClearRightOutline    .ds 1
Data2Weapon            .ds 1
Data3Weapon            .ds 1
address4weapon         .ds 2

AddrOpponentHIT        .ds 2
addr_behavior          .ds 2
addr_action_opponent   .ds 2
addr_joy_opponent      .ds 2 ; adres tablicy z animacjami przeciwnika w zalenoci od ruchu Joysticka+fire
AddrOpponentBitmap     .ds 2

OpponentColor          .ds 1
Opponent               .ds 1
OpponentPl1            .ds 1
OpponentPl2            .ds 1
AddrBar03              .ds 2
YLine2                 .ds 1
StoreYLine2            .ds 1

address5Opponent       .ds 2
address6Opponent       .ds 2
address7Opponent       .ds 2
AddrPlayer             .ds 2

ChangeScreenBuffor     .ds 1 ; aktualnie widoczny bufor ekranu (wartoci: 0 lub 1)
XCoordinateWeapon      .ds 1
YCoordinateWeapon      .ds 1
Data1Weapon            .ds 1
Data5Weapon            .ds 1
Data6Weapon            .ds 1

address5Weapon         .ds 2
address6Weapon         .ds 2
address7Weapon         .ds 2
address8Weapon         .ds 2
Storeaddress5Weapon    .ds 2
address4ANDWeapon      .ds 2
address4BufforWeapon   .ds 2
Index1                 .ds 1
AddrWeaponBitmap       .ds 2
ChangeAddrPMBASE       .ds 1
reg_a                  .ds 1
reg_x                  .ds 1
reg_y                  .ds 1
pom1                   .ds 2 ; oglnego wykorzystania
pom2                   .ds 2 ; oglnego wykorzystania
pom3                   .ds 2 ; oglnego wykorzystania

address4               .ds 2
address5               .ds 2
address6               .ds 2
address7               .ds 2
address8               .ds 2
Data1                  .ds 1
Data2                  .ds 1
Data3                  .ds 1
Data4                  .ds 1
Data5                  .ds 1
Data1Opponent          .ds 1
Counter1Opponent       .ds 1
@stack_pointer         .ds 1

; $FB-$FF wykorzystywane przez player MPT

; wskaniki stosu programowego
@stack_address         = $400

; Wykorzystywane 65 komrki pamici na spamitanie wszystkich ewentualnie dostpnych bankw pamici (1088 KB)
StandardMemory         = $FE ;3E
@TAB_MEM_BANKS         = BANKS-1  ;$05BB
@PROC_ADD_BANK         = $0500
BANKS                  = $05BC
BANKS0                 = $05BC
BANKS1                 = $05BD
BANKS2                 = $05BE
BANKS3                 = $05BF
BANKS4                 = $05C0
BANKS5                 = $05C1
BANKS6                 = $05C2
BANKS7                 = $05C3
BANKS8                 = $05C4
BANKS9                 = $05C5
BANKS10                = $05C6
BANKS11                = $05C7
BANKS12                = $05C8
BANKS13                = $05C9
BANKS14                = $05CA
BANKS15                = $05CB

; IO EQUATES

ICHID    =   $00
ICDNO    =   $01
ICCOM    =   $02
ICSTA    =   $03
ICBAL    =   $04
ICBAH    =   $05
ICPTL    =   $06
ICPTH    =   $07
ICBLL    =   $08
ICBLH    =   $09
ICAX1    =   $0A
ICAX2    =   $0B
ICAX3    =   $0C
ICAX4    =   $0D
ICAX5    =   $0E
ICAX6    =   $0F
;
; DISPLAY LIST EQUATES
;
ADLI     =   $80
AVB      =   $40
ALMS     =   $40
AVSCR    =   $20
AHSCR    =   $10
AJMP     =   $01
AEMPTY1  =   $00
AEMPTY2  =   $10
AEMPTY3  =   $20
AEMPTY4  =   $30
AEMPTY5  =   $40
AEMPTY6  =   $50
AEMPTY7  =   $60
AEMPTY8  =   $70
;
; OS VARIABLES FOR XL/XE
;
; PAGE 0
;
NGFLAG   =   $01
CASINI   =   $02 ;2
RAMLO    =   $04 ;2
TRAMSZ   =   $06
CMCMD    =   $07
WARMST   =   $08
BOOT     =   $09
DOSVEC   =   $0A ;2
DOSINI   =   $0C ;2
APPMHI   =   $0E ;2
POKMSK   =   $10
BRKKEY   =   $11
RTCLOK   =   $12 ;3
BUFADR   =   $15 ;2
ICCOMT   =   $17
DSKFMS   =   $18 ;2
DSKUTL   =   $1A ;2
ABUFPT   =   $1C ;4
ICHIDZ   =   $20
ICDNOZ   =   $21
ICCOMZ   =   $22
ICSTAZ   =   $23
ICBALZ   =   $24
ICBAHZ   =   $25
ICPTLZ   =   $26
ICPTHZ   =   $27
ICBLLZ   =   $28
ICBLHZ   =   $29
ICAX1Z   =   $2A
ICAX2Z   =   $2B
ICAX3Z   =   $2C
ICAX4Z   =   $2D
ICAX5Z   =   $2E
ICAX6Z   =   $2F
STATUS   =   $30
CHKSUM   =   $31
BUFRLO   =   $32
BUFRHI   =   $33
BFENLO   =   $34
BFENHI   =   $35
LTEMP    =   $36 ;2
BUFRFL   =   $38
RECVDN   =   $39
XMTDON   =   $3A
CHKSNT   =   $3B
NOCKSM   =   $3C
BPTR     =   $3D
FTYPE    =   $3E
FEOF     =   $3F
FREQ     =   $40
SOUNDR   =   $41
CRITIC   =   $42
FMSZPG   =   $43 ;7
ZCHAIN   =   $4A ;2
DSTAT    =   $4C
ATRACT   =   $4D
DRKMSK   =   $4E
COLRSH   =   $4F
TEMP     =   $50
HOLD1    =   $51
LMARGN   =   $52
RMARGN   =   $53
ROWCRS   =   $54
COLCRS   =   $55 ;2
DINDEX   =   $57
SAVMSC   =   $58 ;2
OLDROW   =   $5A
OLDCOL   =   $5B ;2
OLDCHR   =   $5D
OLDADR   =   $5E ;2
FKDEF    =   $60 ;2
PALNTS   =   $62
LOGCOL   =   $63
ADRESS   =   $64 ;2
MLTTMP   =   $66 ;2
SAVADR   =   $68 ;2
RAMTOP   =   $6A
BUFCNT   =   $6B
BUFSTR   =   $6C ;2
BITMSK   =   $6E
SHFAMT   =   $6F
ROWAC    =   $70 ;2
COLAC    =   $72 ;2
ENDPT    =   $74 ;2
DELTAR   =   $76
DELTAC   =   $77 ;2
KEYDEF   =   $79 ;2
SWPFLG   =   $7B
HOLDCH   =   $7C
INSDAT   =   $7D
COUNTR   =   $7E ;2
LOMEM    =   $80 ;2
VNTP     = $0082
VNTD     = $0084
VVTP     = $0086
STMTAB   = $0088
STMCUR   = $008A
STARP    = $008C
RUNSTK   = $008E
TOPSTK   = $0090
MEOLFLG  = $0092
POKADR   = $0095
DATAD    = $00B6
DATALN   = $00B7
STOPLN   = $00BA
SAVCUR   = $00BE
IOCMD    = $00C0
IODVC    = $00C1
PROMPT   = $00C2
ERRSAVE  = $00C3
COLOUR   = $00C8
PTABW    = $00C9
LOADFLG  = $00CA
FR0      = $00D4
FRE      = $00DA
FR1      = $00E0
FR2      = $00E6
FRX      = $00EC
EEXP     = $00ED
NSIGN    = $00EE
ESIGN    = $00EF
FCHRFLG  = $00F0
DIGRT    = $00F1
CIX      = $00F2
INBUFF   = $00F3
ZTEMP1   = $00F5
ZTEMP4   = $00F7
ZTEMP3   = $00F9
RADFLG   = $00FB
FLPTR    = $00FC
FPTR2    = $00FE
;
; PAGE 2
;
VDSLST   =   $0200 ;2
VPRCED   =   $0202 ;2
VINTER   =   $0204 ;2
VBREAK   =   $0206 ;2
VKEYBD   =   $0208 ;2
VSERIN   =   $020A ;2
VSEROR   =   $020C ;2
VSEROC   =   $020E ;2
VTIMR1   =   $0210 ;2
VTIMR2   =   $0212 ;2
VTIMR4   =   $0214 ;2
VIMIRQ   =   $0216 ;2
CDTMV1   =   $0218 ;2
CDTMV2   =   $021A ;2
CDTMV3   =   $021C ;2
CDTMV4   =   $021E ;2
CDTMV5   =   $0220 ;2
VVBLKI   =   $0222 ;2
VVBLKD   =   $0224 ;2
CDTMA1   =   $0226 ;2
CDTMA2   =   $0228 ;2
CDTMF3   =   $022A
SRTIMR   =   $022B
CDTMF4   =   $022C
INTEMP   =   $022D
CDTMF5   =   $022E
SDMCTL   =   $022F
SDLSTL   =   $0230
SDLSTH   =   $0231
SSKCTL   =   $0232
SPARE    =   $0233
LPENH    =   $0234
LPENV    =   $0235
BRKKY    =   $0236 ;2
VPIRQ    =   $0238 ;2
CDEVIC   =   $023A
CCOMND   =   $023B
CAUX1    =   $023C
CAUX2    =   $023D
TMPSIO   =   $023E
ERRFLG   =   $023F
DFLAGS   =   $0240
DBSECT   =   $0241
BOOTAD   =   $0242 ;2
COLDST   =   $0244
RECLEN   =   $0245
DSKTIM   =   $0246
PDVMSK   =   $0247
SHPDVS   =   $0248
PDMSK    =   $0249
RELADR   =   $024A ;2
PPTMPA   =   $024C
PPTMPX   =   $024D
CHSALT   =   $026B
VSFLAG   =   $026C
KEYDIS   =   $026D
FINE     =   $026E
GPRIOR   =   $026F
PADDL0   =   $0270
PADDL1   =   $0271
PADDL2   =   $0272
PADDL3   =   $0273
PADDL4   =   $0274
PADDL5   =   $0275
PADDL6   =   $0276
PADDL7   =   $0277
STICK0   =   $0278
STICK1   =   $0279
STICK2   =   $027A
STICK3   =   $027B
PTRIG0   =   $027C
PTRIG1   =   $027D
PTRIG2   =   $027E
PTRIG3   =   $027F
PTRIG4   =   $0280
PTRIG5   =   $0281
PTRIG6   =   $0282
PTRIG7   =   $0283
STRIG0   =   $0284
STRIG1   =   $0285
STRIG2   =   $0286
STRIG3   =   $0287
HIBYTE   =   $0288
WMODE    =   $0289
BLIM     =   $028A
IMASK    =   $028B
JVECK    =   $028C
NEWADR   =   $028E
TXTROW   =   $0290
TXTCOL   =   $0291 ;2
TINDEX   =   $0293
TXTMSC   =   $0294 ;2
TXTOLD   =   $0296 ;6
CRETRY   =   $029C
HOLD3    =   $029D
SUBTMP   =   $029E
HOLD2    =   $029F
DMASK    =   $02A0
TMPLBT   =   $02A1
ESCFLG   =   $02A2
TABMAP   =   $02A3 ;15
LOGMAP   =   $02B2 ;4
INVFLG   =   $02B6
FILFLG   =   $02B7
TMPROW   =   $02B8
TMPCOL   =   $02B9 ;2
SCRFLG   =   $02BB
HOLD4    =   $02BC
DRETRY   =   $02BD
SHFLOC   =   $02BE
BOTSCR   =   $02BF
PCOLR0   =   $02C0
PCOLR1   =   $02C1
PCOLR2   =   $02C2
PCOLR3   =   $02C3
COLOR0   =   $02C4
COLOR1   =   $02C5
COLOR2   =   $02C6
COLOR3   =   $02C7
COLOR4   =   $02C8
COLBAK   =   $02C8
RUNADR   =   $02C9 ;2
HIUSED   =   $02CB ;2
ZHIUSE   =   $02CD ;2
GBYTEA   =   $02CF ;2
LOADAD   =   $02D1 ;2
ZLOADA   =   $02D3 ;2
DSCTLN   =   $02D5 ;2
ACMISR   =   $02D7 ;2
KRPDER   =   $02D9
KEYREP   =   $02DA
NOCLIK   =   $02DB
HELPFG   =   $02DC
DMASAV   =   $02DD
PBPNT    =   $02DE
PBUFSZ   =   $02DF
RUNAD    =   $02E0 ;2
INITAD   =   $02E2 ;2
RAMSIZ   =   $02E4
MEMTOP   =   $02E5 ;2
MEMLO    =   $02E7 ;2
HNDLOD   =   $02E9
DVSTAT   =   $02EA ;4
CBAUDL   =   $02EE
CBAUDH   =   $02EF
CRSINH   =   $02F0
KEYDEL   =   $02F1
CH1      =   $02F2
CHACT    =   $02F3
CHBAS    =   $02F4
NEWROW   =   $02F5
NEWCOL   =   $02F6 ;2
ROWINC   =   $02F8
COLINC   =   $02F9
CHAR     =   $02FA
ATACHR   =   $02FB
CH       =   $02FC
FILDAT   =   $02FD
DSPFLG   =   $02FE
SSFLAG   =   $02FF
;
; PAGE 3
;
DDEVIC   =   $0300
DUNIT    =   $0301
DCOMND   =   $0302
DSTATS   =   $0303
DBUFLO   =   $0304
DBUFHI   =   $0305
DTIMLO   =   $0306
DUNUSE   =   $0307
DBYTLO   =   $0308
DBYTHI   =   $0309
DAUX1    =   $030A
DAUX2    =   $030B
TIMER1   =   $030C ;2
ADDCOR   =   $030E
CASFLG   =   $030F
TIMER2   =   $0310 ;2
TEMP1    =   $0312 ;2
TEMP2    =   $0314
TEMP3    =   $0315
SAVIO    =   $0316
TIMFLG   =   $0317
STACKP   =   $0318
TSTAT    =   $0319
HATABS   =   $031A ;35
PUPBT1   =   $033D
PUPBT2   =   $033E
PUPBT3   =   $033F
IOCB0    =   $0340
IOCB0.ICDNO = $0341
IOCB0.ICCOM = $0342
IOCB0.ICSTA = $0343
IOCB0.ICBAL = $0344
IOCB0.ICBAH = $0345
IOCB0.ICPTL = $0346
IOCB0.ICPTH = $0347
IOCB0.ICBLL = $0348
IOCB0.ICBLH = $0349
IOCB0.ICAX1 = $034A
IOCB0.ICAX2 = $034B
IOCB0.ICAX3 = $034C
IOCB0.ICAX4 = $034D
IOCB0.ICAX5 = $034E
IOCB0.ICAX6 = $034F
IOCB1    =   $0350
IOCB1.ICDNO = $0351
IOCB1.ICCOM = $0352
IOCB1.ICSTA = $0353
IOCB1.ICBAL = $0354
IOCB1.ICBAH = $0355
IOCB1.ICPTL = $0356
IOCB1.ICPTH = $0357
IOCB1.ICBLL = $0358
IOCB1.ICBLH = $0359
IOCB1.ICAX1 = $035A
IOCB1.ICAX2 = $035B
IOCB1.ICAX3 = $035C
IOCB1.ICAX4 = $035D
IOCB1.ICAX5 = $035E
IOCB1.ICAX6 = $035F
IOCB2    =   $0360
IOCB2.ICDNO = $0361
IOCB2.ICCOM = $0362
IOCB2.ICSTA = $0363
IOCB2.ICBAL = $0364
IOCB2.ICBAH = $0365
IOCB2.ICPTL = $0366
IOCB2.ICPTH = $0367
IOCB2.ICBLL = $0368
IOCB2.ICBLH = $0369
IOCB2.ICAX1 = $036A
IOCB2.ICAX2 = $036B
IOCB2.ICAX3 = $036C
IOCB2.ICAX4 = $036D
IOCB2.ICAX5 = $036E
IOCB2.ICAX6 = $036F
IOCB3    =   $0370
IOCB3.ICDNO = $0371
IOCB3.ICCOM = $0372
IOCB3.ICSTA = $0373
IOCB3.ICBAL = $0374
IOCB3.ICBAH = $0375
IOCB3.ICPTL = $0376
IOCB3.ICPTH = $0377
IOCB3.ICBLL = $0378
IOCB3.ICBLH = $0379
IOCB3.ICAX1 = $037A
IOCB3.ICAX2 = $037B
IOCB3.ICAX3 = $037C
IOCB3.ICAX4 = $037D
IOCB3.ICAX5 = $037E
IOCB3.ICAX6 = $037F
IOCB4    =   $0380
IOCB4.ICDNO = $0381
IOCB4.ICCOM = $0382
IOCB4.ICSTA = $0383
IOCB4.ICBAL = $0384
IOCB4.ICBAH = $0385
IOCB4.ICPTL = $0386
IOCB4.ICPTH = $0387
IOCB4.ICBLL = $0388
IOCB4.ICBLH = $0389
IOCB4.ICAX1 = $038A
IOCB4.ICAX2 = $038B
IOCB4.ICAX3 = $038C
IOCB4.ICAX4 = $038D
IOCB4.ICAX5 = $038E
IOCB4.ICAX6 = $038F
IOCB5    =   $0390
IOCB5.ICDNO = $0391
IOCB5.ICCOM = $0392
IOCB5.ICSTA = $0393
IOCB5.ICBAL = $0394
IOCB5.ICBAH = $0395
IOCB5.ICPTL = $0396
IOCB5.ICPTH = $0397
IOCB5.ICBLL = $0398
IOCB5.ICBLH = $0399
IOCB5.ICAX1 = $039A
IOCB5.ICAX2 = $039B
IOCB5.ICAX3 = $039C
IOCB5.ICAX4 = $039D
IOCB5.ICAX5 = $039E
IOCB5.ICAX6 = $039F
IOCB6    =   $03A0
IOCB6.ICDNO = $03A1
IOCB6.ICCOM = $03A2
IOCB6.ICSTA = $03A3
IOCB6.ICBAL = $03A4
IOCB6.ICBAH = $03A5
IOCB6.ICPTL = $03A6
IOCB6.ICPTH = $03A7
IOCB6.ICBLL = $03A8
IOCB6.ICBLH = $03A9
IOCB6.ICAX1 = $03AA
IOCB6.ICAX2 = $03AB
IOCB6.ICAX3 = $03AC
IOCB6.ICAX4 = $03AD
IOCB6.ICAX5 = $03AE
IOCB6.ICAX6 = $03AF
IOCB7    =   $03B0
IOCB7.ICDNO = $03B1
IOCB7.ICCOM = $03B2
IOCB7.ICSTA = $03B3
IOCB7.ICBAL = $03B4
IOCB7.ICBAH = $03B5
IOCB7.ICPTL = $03B6
IOCB7.ICPTH = $03B7
IOCB7.ICBLL = $03B8
IOCB7.ICBLH = $03B9
IOCB7.ICAX1 = $03BA
IOCB7.ICAX2 = $03BB
IOCB7.ICAX3 = $03BC
IOCB7.ICAX4 = $03BD
IOCB7.ICAX5 = $03BE
IOCB7.ICAX6 = $03BF
PRNBUF   =   $03C0 ;40
SUPERF   =   $03E8
CKEY     =   $03E9
CASSBT   =   $03EA
CARTCK   =   $03EB
DERRF    =   $03EC
ACMVAR   =   $03ED ;11
BASICF   =   $03F8
MINTLK   =   $03F9
GINTLK   =   $03FA
CHLINK   =   $03FB ;2
CASBUF   =   $03FD
;
; HARDWARE REGISTERS
;
; GTIA
;
M0PF     =   $D000
HPOSP0   =   $D000
M1PF     =   $D001
HPOSP1   =   $D001
M2PF     =   $D002
HPOSP2   =   $D002
M3PF     =   $D003
HPOSP3   =   $D003
P0PF     =   $D004
HPOSM0   =   $D004
P1PF     =   $D005
HPOSM1   =   $D005
P2PF     =   $D006
HPOSM2   =   $D006
P3PF     =   $D007
HPOSM3   =   $D007
M0PL     =   $D008
SIZEP0   =   $D008
M1PL     =   $D009
SIZEP1   =   $D009
M2PL     =   $D00A
SIZEP2   =   $D00A
M3PL     =   $D00B
SIZEP3   =   $D00B
P0PL     =   $D00C
SIZEM    =   $D00C
P1PL     =   $D00D
GRAFP0   =   $D00D
P2PL     =   $D00E
GRAFP1   =   $D00E
P3PL     =   $D00F
GRAFP2   =   $D00F
TRIG0    =   $D010
GRAFP3   =   $D010
TRIG1    =   $D011
GRAFM    =   $D011
TRIG2    =   $D012
COLPM0   =   $D012
TRIG3    =   $D013
COLPM1   =   $D013
PAL      =   $D014
COLPM2   =   $D014
COLPM3   =   $D015
COLPF0   =   $D016
COLPF1   =   $D017
COLPF2   =   $D018
COLPF3   =   $D019
COLBK    =   $D01A
PRIOR    =   $D01B
VDELAY   =   $D01C
GRACTL   =   $D01D
HITCLR   =   $D01E
CONSOL   =   $D01F
;
; POKEY
;
POT0     =   $D200
AUDF1    =   $D200
POT1     =   $D201
AUDC1    =   $D201
POT2     =   $D202
AUDF2    =   $D202
POT3     =   $D203
AUDC2    =   $D203
POT4     =   $D204
AUDF3    =   $D204
POT5     =   $D205
AUDC3    =   $D205
POT6     =   $D206
AUDF4    =   $D206
POT7     =   $D207
AUDC4    =   $D207
ALLPOT   =   $D208
AUDCTL   =   $D208
KBCODE   =   $D209
STIMER   =   $D209
RANDOM   =   $D20A
SKREST   =   $D20A
POTGO    =   $D20B
SERIN    =   $D20D
SEROUT   =   $D20D
IRQST    =   $D20E
IRQEN    =   $D20E
SKSTAT   =   $D20F
SKCTL    =   $D20F
;
; PIA
;
PORTA    =   $D300
PORTB    =   $D301
PACTL    =   $D302
PBCTL    =   $D303
;
; ANTIC
;
DMACLT   =   $D400
CHACTL   =   $D401
DLISTL   =   $D402
DLISTH   =   $D403
HSCROL   =   $D404
VSCROL   =   $D405
PMBASE   =   $D407
CHBASE   =   $D409
WSYNC    =   $D40A
VCOUNT   =   $D40B
PENH     =   $D40C
PENV     =   $D40D
NMIEN    =   $D40E
NMIST    =   $D40F
NMIRES   =   $D40F
;
; FLOATING POINT ROUTINES
;
AFP      =   $D800
FASC     =   $D8E6
IFP      =   $D9AA
FPI      =   $D9D2
ZFR0     =   $DA44
ZF1      =   $DA46
FSUB     =   $DA60
FADD     =   $DA66
FMUL     =   $DADB
FDIV     =   $DB28
PLYEVL   =   $DD40
FLD0R    =   $DD89
FLD0P    =   $DD8D
FLD1R    =   $DD98
FLD1P    =   $DD9C
FSTOR    =   $DDA7
FSTOP    =   $DDAB
FMOVE    =   $DDB6
EXP      =   $DDC0
EXP10    =   $DDCC
LOG      =   $DECD
LOG10    =   $DED1
;
; ROM VECTORS
;
DSKINV   =   $E453
CIOV     =   $E456
SIOV     =   $E459
SETVBV   =   $E45C
SYSVBV   =   $E45F
XITVBV   =   $E462
SIOINV   =   $E465
SENDEV   =   $E468
INTINV   =   $E46B
CIOINV   =   $E46E
SELFSV   =   $E471
WARMSV   =   $E474
COLDSV   =   $E477
RBLOKV   =   $E47A
CSOPIV   =   $E47D
PUPDIV   =   $E480
SELFTSV  =   $E483
PENTV    =   $E486
PHUNLV   =   $E489
PHINIV   =   $E48C
GPDVV    =   $E48F

;------------------------------------------------------------------
; Makro odejmuje parametry (:1 - :2)
; i w A zwraca znak tego wyniku :
; -1 dla ujemnego
;  0 dla 0
; +1 dla dodatniego
; a w X zwraca bezwzgledn(bez znaku) rnic pomidzy parametrami :1 i :2
;------------------------------------------------------------------
SGN .MACRO
      lda :1
      sub :2
      bcs sgn_skip0
      eor #255          ;zmie znak z - na +
      tax
      inx
      lda #-1
      bmi sgn_skip2
sgn_skip0
      bne sgn_skip1
      lda #0
      tax
      beq sgn_skip2
sgn_skip1
      tax
      lda #1
sgn_skip2
.ENDM

; makro kopiuje przerwanie DLI z pamici rozszerzonej do pamieci podstawowej
.MACRO copy_DLI
         lda PORTB
         pha
         ldx #<=:1
         lda @tab_mem_banks,x
         sta PORTB
         CopyMemory #:1,#memory_reserved_for_DLI,#:2
         pla
         sta PORTB
.ENDM
