/*
 przykladowy program wykorzystujacy deklaracje procedury .PROC ze stosem programowym oraz typu .REG

 program realizuje zamiane wartosci typu WORD na postac hexadecymalna

 ostatnia modyfikacja: 27.05.2006
*/

 org $2000

@stack_address = $400	; adres poczatku stosu - wymagana przez MADS deklaracja etykiety dla .PROC z parametrami
@stack_pointer = $ff	; wskaznik stosu       - wymagana przez MADS deklaracja etykiety dla .PROC z parametrami
@proc_vars_adr = $80	; obszar gdzie skladowane sa parametry przekazywane do procedur

main
	mva #0  @stack_pointer		; zerujemy wskaznik stosu programowego

	hex #$12b5 , #$bc40+18+10*40	; wywolujemy procedure HEX, pierwszym parametrem jest wartosc #$12b5
					; drugi parametr to adres pamieci obrazu gdzie zostanie wyswietlony tekst z wartoscia HEX

	jmp *				; petla bez konca, aby zobaczyc efekt dzialania



* ----------- *
*  PROCEDURE  *
* ----------- *
// procedurka reprezentujaca wartosc 1-bajtowa (BYTE) w postaci HEXadecymalnej
lHex	.proc ( .byte a ) .reg

// dyrektywa .REG okresla sposob przekazywania parametrow do procedury, przez rejestry CPU
// nazwy parametrow moga skladac sie tylko z liter A,X,Y i ich kombinacji
// maksymalnie mozemy w ten sposob przekazac 3 bajty
// w ciele procedury mozemy uzywac nazw etykiet A,X,Y poniewaz nie sa one definiowane przez .PROC
// jak w przypadku pozostalych sposob przekazywania parametrow do procedur .PROC

	pha
	:4 lsr @
	tay

	ldx thex,y

	pla
	and #$0f
	tay

	lda thex,y
	rts

thex dta d'0123456789ABCDEF'

	.endp


// procedurka reprezentujaca wartosc 2-bajtowa (WORD) w postaci HEXadecymalnej
hex	.proc ( .word par1,out )

// po deklaracji procedury .PROC z parametrami i bez okreslonego sposobu przekazywania tych parametrow,
// automatycznie wymuszone zostaje wykonanie makra @PULL, ktore zdejmie za nas parametry ze stosu programowego
// i umiesci je w pamieci od adresu @PROC_VARS_ADR, etykiecie parametru PAR1 zostaje przypisany
// adres @PROC_VARS_ADR

	lHex par1

	ldy #3
	jsr put

	lHex par1+1

	ldy #1
	jsr put

	rts		; wyjscie z procedury HEX

put	sta (out),y	; regA
	dey
	txa
	sta (out),y	; regX
	rts

	.endp


 opt l-
 icl 'macros/@call.mac'
 icl 'macros/@pull.mac'
 icl 'macros/@exit.mac'

; ---
 run main
