
; BCALC
; zadaniem procedury BCALC jest odczytanie 4*COLS znakow i obliczenie ich adresow
; dodatkowo po odczytaniu znakow zastepowane sa one nowymi znakami: FREE, FREE+1 ... FREE+COLS
;
; zmienna BUFOR okresla dla jakiego bufora odbedzie sie asemblacja
; zmienna COLS okresla maksymalna liczbe kolumn znakow przypadajaca na ducha (liczba wierszy jest stala = 4)
;
; upublicznianym adresem uruchomienia jest BCALC 
;


	icl 'global\global.hea'


	ift bufor=2
	Buf	= B2scr
	Fnt	= B2fnt0
	eli bufor=3
	Buf	= B3scr
	Fnt	= B3fnt0
	els
	ert "not defined"
	eif


fnt0	= Fnt
fnt1	= fnt0+$0400
fnt2	= fnt1+$0400
fnt3	= fnt2+$0400

	.public	bcalc


	org $4000


	.pages $40

lchar0	:256 dta l(fnt0+(#&127)*8)
hchar0	:256 dta h(fnt0+(#&127)*8)
lchar1	:256 dta l(fnt1+(#&127)*8)
hchar1	:256 dta h(fnt1+(#&127)*8)
lchar2	:256 dta l(fnt2+(#&127)*8)
hchar2	:256 dta h(fnt2+(#&127)*8)
lchar3	:256 dta l(fnt3+(#&127)*8)
hchar3	:256 dta h(fnt3+(#&127)*8)

ladr	dta l(r0,r1,r2,r3,r4,r5,r6,r7,r8,r9,r10,r11,r12,r13,r14,r15,r16,r17,r18,r19,r20,r21,r22,r23)	
hadr	dta h(r0,r1,r2,r3,r4,r5,r6,r7,r8,r9,r10,r11,r12,r13,r14,r15,r16,r17,r18,r19,r20,r21,r22,r23)

; obliczenie adresu skoku wg wspolrzednych ducha

bcalc
	lda posx
	:2 lsr @
	tax

	lda posy
	:3 lsr @
	tay

	lda ladr,y
	sta _jmp+1
	lda hadr,y
	sta _jmp+2

_jmp	jmp $ffff


; obliczenie adresow SCR i DST dla jednego ducha

	?row = 0

r0	ROW 	;charset 0
r1	ROW 	;charset 1
r2	ROW 	;charset 2
r3	ROW 	;charset 3
r4	ROW 	;charset 0
r5	ROW 	;charset 1
r6	ROW 	;charset 2
r7	ROW 	;charset 3
r8	ROW 	;charset 0
r9	ROW 	;charset 1
r10	ROW 	;charset 2
r11	ROW 	;charset 3
r12	ROW 	;charset 0
r13	ROW 	;charset 1
r14	ROW 	;charset 2
r15	ROW 	;charset 3
r16	ROW 	;charset 0
r17	ROW 	;charset 1
r18	ROW 	;charset 2
r19	ROW 	;charset 3
r20	ROW 	;charset 0
r21	ROW 	;charset 1
r22	ROW 	;charset 2
r23	ROW 	;charset 3

	.endpg
*---

	.print '$4000..',*

	blk update public


*---	MACROS

	opt l-



ROW	.macro " "
	?cnt = 0
	?col = 0

	.rept COLS
	ADR	<[?row+?cnt]&3	<?cnt
	ADR	<[?row+?cnt]&3	<?cnt
	ADR	<[?row+?cnt]&3	<?cnt
	ADR	<[?row+?cnt]&3	<?cnt
	?col++
	.endr

DROW
	?cnt = 0
	?col = 0
	ldy free	; optymalizacja dla DST, znaki sa uporzadkowane wiec wystarczy znac tylko pierwszy z nich

	.rept COLS
	DADR <[?row+?cnt]&3 <?cnt
	iny
	.endr

	sty free

	rts

	?row++
	.endm


ADR	.macro " "
	ldy Buf+@sw*[?row+?cnt&3]+?col,x
	lda lchar:2,y
	sta zp[:4].src
	lda hchar:2,y
	sta zp[:4].src+1

	?cnt++
	.endm


HIGH	.macro " "

	lda hchar:2,y
	sta zp[:4].dst+1

	.endm


DADR	.macro " "

	?c = ?cnt

	lda lchar:2,y
	sta zp[?c].dst
	sta zp[?c+1].dst
	sta zp[?c+2].dst
	sta zp[?c+3].dst

	?c = ?cnt
	?b = [?row+?c]&3
	HIGH <?b <?c
	?c = ?cnt+1
	?b = [?row+?c]&3
	HIGH <?b <?c
	?c = ?cnt+2
	?b = [?row+?c]&3
	HIGH <?b <?c
	?c = ?cnt+3
	?b = [?row+?c]&3
	HIGH <?b <?c

	tya
	ora B1inv+@sw*[?row+?cnt&3]+?col,x
	sta Buf+@sw*[?row+?cnt&3]+?col,x
	?cnt++
	tya
	ora B1inv+@sw*[?row+?cnt&3]+?col,x
	sta Buf+@sw*[?row+?cnt&3]+?col,x
	?cnt++
	tya
	ora B1inv+@sw*[?row+?cnt&3]+?col,x
	sta Buf+@sw*[?row+?cnt&3]+?col,x
	?cnt++
	tya
	ora B1inv+@sw*[?row+?cnt&3]+?col,x
	sta Buf+@sw*[?row+?cnt&3]+?col,x
	?cnt++

	?col++

	.endm
