
* ---	TABLICE
;
; najlepiej zeby zaczynaly sie od poczatku strony, czy tez miescily sie w jej granicach
;

*---
	align

* ---	shpAdr, mskAdr 

	?b = 17*8		; liczba znakow przypadajaca na 1 klatke animacji (duch12x24), znak 17 jest pusty i jest konieczny
;	?c = $800/?b
	?c = 16			; aby wyrownac do polowy strony

mskAdr12	:?c	_ADRH #	$6000,$6800,$7000,$7800

shpAdr12	:?c	_ADR # 	$4000,$4800,$5000,$5800

	ert .lo(mskAdr12)<>0	; mskAdr12 koniecznie od poczatku strony pamieci

	?b = 13*8		; liczba znakow przypadajaca na 1 klatke animacji (duch8x24), znak 13 jest pusty i jest konieczny
;	?c = $800/?b
	?c = 32			; aby wyrownac do pelnej strony

shpAdr8		:?c	_ADR # 	$4000,$4800,$5000,$5800

mskAdr8		:?c	_ADRH #	$6000,$6800,$7000,$7800

	ert .lo(mskAdr8)<>0	; mskAdr8 koniecznie od poczatku strony pamieci


_ADR	.macro
	dta a(:2+:1*?b)
	dta a(:3+:1*?b)
	dta a(:4+:1*?b)
	dta a(:5+:1*?b)
	.endm

_ADRH	.macro
	dta h(:2+:1*?b , :2+:1*?b)
	dta h(:3+:1*?b , :3+:1*?b)
	dta h(:4+:1*?b , :4+:1*?b)
	dta h(:5+:1*?b , :5+:1*?b)
	.endm


* ---	MUL8
; stablicowane wartosci wyrazenia: <0..31> * 8
; tablica MUL8 sluzy do obliczenia wlasciwego ofsetu dla tablic SHP i MSK przechowywanych w dodatkowych bankach pamieci

mul8	:32	dta #*8



* ---	STRUKTURY DANYCH
; rozmiar struktury @SPRITE limituje maksymalna liczbe duchow (256/@SPRITE)
; rozmiar struktury @SHAPE limituje maksymalna liczbe ksztaltow duchow (256/@SHAPE)

@SPRITE	.struct
	prg	.word	; adres programu obslugi ducha

	shp	.byte	; rodzaj ducha = indeks do tablicy SHAPES (aby otrzymac indeks trzeba pomnozyc przez dlugosc struktury @SHAPE)
	psx	.byte	; pozycja pozioma X
	psy	.byte	; pozycja pionowa Y
	frm	.byte	; aktualny numer klatki animacji sprita
	sts	.byte	; status sprita (=0 nieaktywny czyli niewidoczny, <>0 aktywny czyli widoczny)
	new	.byte	; <>0 oznacza ze duch zostal dopisany w aktualnej kolejce i dlatego zostanie obsluzony dopiero nastepnym razem
	hpm	.byte	; <$01..$04> podkolorowac duchem sprzetowym 1-4, <$81..$84> podkolorowac pociskiem sprzetowym 1-4

	use0	.byte	; 4-y bajty do wykorzystania przez program obslugi ducha
	use1	.byte
	use2	.byte
	use3	.byte
	.ends


@SHAPE	.struct
	bnk	.byte	; bank z danymi ducha (wartosc dla rejestru PORTB)
	frm	.byte	; liczba klatek animacji ducha
	typ	.byte	; =0 duch 12x24, <>0 duch 8x24
	hig	.byte	; wysokosc dla tego ksztaltu, wartosc pomocna przy detekcji kolizji
			; duchy zawsze maja wysokosc 24 linii ale nie zawsze wszystkie linie sa wykorzystane
			; minimalna wartosc HIG = 5, !!! nie wolno wstawic mniejszej wartosci !!!
	.ends

	ert @shape<>4	; struktura @SHAPE musi opisywac 4 bajty, po to aby mozna bylo uzyc ":2 ASL @" do wyliczenia ofsetu


	align

shapes	dta	@shape	[max_shapes-1]
sprites	dta	@sprite	[max_sprites-1]
